'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _directories = require('../directories');

var _multiLink = require('../directories/multi-link');

var _multiLink2 = _interopRequireDefault(_multiLink);

var _bitMap = require('../bit-map');

var _bitMap2 = _interopRequireDefault(_bitMap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var stripNonRelevantDataFromLinks = function stripNonRelevantDataFromLinks(allLinks, projectRoot) {
  var links = {};
  var stripProjectRoot = function stripProjectRoot(str) {
    return str.replace(`${projectRoot}${_path2.default.sep}`, '');
  };
  Object.keys(allLinks).forEach(function (link) {
    if (allLinks[link] instanceof _multiLink2.default) return;
    links[stripProjectRoot(link)] = stripProjectRoot(allLinks[link].to);
  });
  return links;
};

exports.default = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref) {
    var _ref$projectRoot = _ref.projectRoot,
        projectRoot = _ref$projectRoot === undefined ? process.cwd() : _ref$projectRoot;
    var bitModuleDirectory, componentsDirectory, bitMap, componentsMap, allLinks;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            bitModuleDirectory = new _directories.BitModuleDirectory(projectRoot);
            componentsDirectory = new _directories.ComponentsDirectory(projectRoot);
            _context.next = 4;
            return _bitMap2.default.load(projectRoot);

          case 4:
            bitMap = _context.sent;
            _context.next = 7;
            return bitModuleDirectory.erase();

          case 7:
            componentsMap = bitMap.getAllComponents();


            bitModuleDirectory.addLinksFromBitMap(componentsMap);
            bitModuleDirectory.addLinksForNamespacesAndRoot(componentsMap);
            componentsDirectory.addLinksToDependencies(componentsMap);

            _context.next = 13;
            return bitModuleDirectory.persist();

          case 13:
            _context.next = 15;
            return componentsDirectory.persist();

          case 15:
            allLinks = _ramda2.default.mergeAll([bitModuleDirectory.links, componentsDirectory.links]);
            return _context.abrupt('return', stripNonRelevantDataFromLinks(allLinks, projectRoot));

          case 17:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function bindAction(_x) {
    return _ref2.apply(this, arguments);
  }

  return bindAction;
}();
//# sourceMappingURL=bind.js.map