'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _constants = require('../constants');

var _invalidBitMap = require('./exceptions/invalid-bit-map');

var _invalidBitMap2 = _interopRequireDefault(_invalidBitMap);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var BitMap = function () {
  function BitMap(projectRoot, mapPath, components) {
    _classCallCheck(this, BitMap);

    this.projectRoot = projectRoot;
    this.mapPath = mapPath;
    this.components = components;
  }

  _createClass(BitMap, [{
    key: 'isComponentExist',
    value: function isComponentExist(componentId) {
      return !!this.components[componentId];
    }
  }, {
    key: 'getAllComponents',
    value: function getAllComponents() {
      return this.components;
    }
  }, {
    key: 'getComponent',
    value: function getComponent(id) {
      return this.components[id];
    }
  }], [{
    key: 'load',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee(dirPath) {
        var mapPath, components, mapFileContent;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                mapPath = _path2.default.join(dirPath, _constants.BIT_MAP);
                components = void 0;

                if (!_fsExtra2.default.existsSync(mapPath)) {
                  _context.next = 15;
                  break;
                }

                _context.prev = 3;
                _context.next = 6;
                return (0, _utils.readFileP)(mapPath);

              case 6:
                mapFileContent = _context.sent;

                components = JSON.parse(mapFileContent.toString('utf8'));
                _context.next = 13;
                break;

              case 10:
                _context.prev = 10;
                _context.t0 = _context['catch'](3);
                throw new _invalidBitMap2.default(mapPath);

              case 13:
                _context.next = 16;
                break;

              case 15:
                components = {};

              case 16:
                return _context.abrupt('return', new BitMap(dirPath, mapPath, components));

              case 17:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[3, 10]]);
      }));

      function load(_x) {
        return _ref.apply(this, arguments);
      }

      return load;
    }()
  }]);

  return BitMap;
}();

exports.default = BitMap;
//# sourceMappingURL=bit-map.js.map