'use strict';

module.exports = function (src) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var compiler = require('vue-template-compiler');
  var finalDependencies = {};
  var addDependencies = function addDependencies(dependencies, isScript) {
    var objDependencies = {};
    if (Array.isArray(dependencies)) {
      dependencies.forEach(function (dependency) {
        objDependencies[dependency] = {};
      });
    } else {
      objDependencies = dependencies;
    }
    Object.keys(objDependencies).forEach(function (dependency) {
      finalDependencies[dependency] = objDependencies[dependency];
      finalDependencies[dependency].isScript = isScript;
    });
  };

  options.useContent = true;

  var _compiler$parseCompon = compiler.parseComponent(src, { pad: 'line' }),
      script = _compiler$parseCompon.script,
      styles = _compiler$parseCompon.styles;
  // it must be required here, otherwise, it'll be a cyclic dependency


  var precinct = require('../../precinct');
  if (script) {
    var dependencies = precinct(script.content, options);
    addDependencies(dependencies, true);
  }
  if (styles) {
    styles.forEach(function (style) {
      var dependencies = precinct(style.content, { type: style.lang || 'scss' });
      addDependencies(dependencies, false);
    });
  }

  return finalDependencies;
};
//# sourceMappingURL=index.js.map